<?php
/**************************************************
  Coppermine Plugin - Sitemap Generator
  *************************************************
  Copyright (c) 2011 Allyson Moisan
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
***************************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

global $CONFIG, $lang_errors;

require_once "./plugins/sitemap_generator/lang/english.php";

if ($CONFIG['lang'] != 'english' && file_exists("./plugins/sitemap_generator/lang/{$CONFIG['lang']}.php")) {
    require_once "./plugins/sitemap_generator/lang/{$CONFIG['lang']}.php";
}

if (!GALLERY_ADMIN_MODE) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);

require_once "./plugins/sitemap_generator/functions.php";

$sitemaphead = '';
$message = 'initial';
$dirError = false;
$fileError = false;
$base = rtrim($CONFIG['ecards_more_pic_target'], '/');
$fullpath = rtrim($CONFIG['fullpath'], '/');
$stylesheet = $base.'/plugins/sitemap_generator/xml-sitemap.xsl';
$public = "AND (ISNULL(alb_password) OR alb_password = '') AND visibility = '0'";

/* Delete old Sitemap files, if they exist */
if (!rmDirFiles('sitemaps'))
	cpg_die(ERROR, $lang_plugin_sitemap_gen['old_file_removal_error'], __FILE__, __LINE__);

/* Get Gallery info */
$cats = cpg_db_query("SELECT cid FROM {$CONFIG['TABLE_CATEGORIES']}");

if (!$cats) cpg_die(ERROR, $lang_plugin_sitemap_gen['empty_gallery_error'], __FILE__, __LINE__);

/* Build Sitemap Index */
$sitemaphead = '<?xml version="1.0" encoding="UTF-8"?>';
$sitemaphead .= '<?xml-stylesheet type="text/xsl" href="'.$stylesheet.'"?>';
$sitemaphead .= '<sitemapindex xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
$sitemaphead .= '</sitemapindex>';

$sitemaphead = utf8_encode($sitemaphead);
$xmlsitemap = new SimpleXMLElement($sitemaphead);

while(list($cid) = mysql_fetch_row($cats))
{	
	list($alb_count) = mysql_fetch_row(cpg_db_query( "SELECT COUNT(aid) FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$cid' $public LIMIT 1" ));
	/* don't include categories with no albums */
	if (!$alb_count) continue;
	
	/* don't include categories with no pics */
	list($pic_count) = mysql_fetch_row(cpg_db_query( "SELECT COUNT(pid) FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE category = $cid $public LIMIT 1" ));
	if (!$pic_count) continue;
	
	list($aid, $date) = mysql_fetch_row(cpg_db_query("SELECT a.aid, MAX(ctime) FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE category = $cid $public GROUP BY a.aid ORDER BY ctime DESC LIMIT 1"));
	$date = date( 'c', $date );
	
	$sitemap = $xmlsitemap->addChild('sitemap');
	$sitemap->addChild('loc', $base.'/sitemaps/cat'.$cid.'-sitemap.xml');
	$sitemap->addChild('lastmod', $date);
}

/* Output Sitemap Index to a file in directory named sitemaps */
if (!is_dir('sitemaps')) {
	if(!mkdir('sitemaps', 0775)) {
		if(!mkDirFix('sitemaps', 0775))
			$dirError = true;
	}
}

/* Format XML to save indented tree rather than one line */
$dom = new DOMDocument('1.0');
$dom->preserveWhiteSpace = false;
$dom->formatOutput = true;
$dom->loadXML($xmlsitemap->asXML());

/* Save XML to file */
if (!$dom->save('sitemaps/sitemap_index.xml')) {
	if(!$message = mkFileFix($dom->saveXML(), 'sitemaps/sitemap_index.xml'))
		$fileError = true;
} 

$sitemaphead = '';
$cats = cpg_db_query("SELECT cid FROM {$CONFIG['TABLE_CATEGORIES']}");

if (!$cats) cpg_die(ERROR, $lang_plugin_sitemap_gen['empty_gallery_error'], __FILE__, __LINE__);

if (!$dirError && !$fileError) {
	
	/* Build Sitemaps */
	while(list($cid) = mysql_fetch_row($cats))
	{	
		$sitemaphead = '<?xml version="1.0" encoding="UTF-8"?>';
		$sitemaphead .= '<?xml-stylesheet type="text/xsl" href="'.$stylesheet.'"?>';
		$sitemaphead .= '<urlset xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ';
		$sitemaphead .= 'xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd" ';
		$sitemaphead .= 'xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" ';
		$sitemaphead .= 'xmlns:html="http://www.w3.org/TR/REC-html40" ';
		$sitemaphead .= 'xmlns:image="http://www.google.com/schemas/sitemap-image/1.1" ';
		$sitemaphead .= 'xmlns:video="http://www.google.com/schemas/sitemap-video/1.1" ';
		$sitemaphead .= 'xmlns:xsl="http://www.w3.org/1999/XSL/Transform">';
		$sitemaphead .= '</urlset>';
		
		$sitemaphead = utf8_encode($sitemaphead);
		$xmlmap = new SimpleXMLElement($sitemaphead);
		
		list($alb_count) = mysql_fetch_row(cpg_db_query( "SELECT COUNT(aid) FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$cid' $public LIMIT 1" ));
		/* don't include categories with no albums */
		if (!$alb_count) continue;
		
		/* don't include categories with no pics */
		list($pic_count) = mysql_fetch_row(cpg_db_query( "SELECT COUNT(pid) FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE category = $cid $public LIMIT 1" ));
		if (!$pic_count) continue;
		
		list($aid, $date) = mysql_fetch_row(cpg_db_query("SELECT a.aid, MAX(ctime) FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE category = $cid $public GROUP BY a.aid ORDER BY ctime DESC LIMIT 1"));
		$date = date( 'c', $date );
		
		$urlcat = $xmlmap->addChild('url');
		$urlcat->addChild('loc', $base.'/index.php?cat='.$cid);
		$urlcat->addChild('lastmod', $date);
		$urlcat->addChild('changefreq', 'daily');
		$urlcat->addChild('priority', '1');
		
		$albs = cpg_db_query("SELECT a.aid, MAX(ctime) FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE category = '$cid' $public GROUP BY a.aid");
		
		while(list($aid, $lastmod) = mysql_fetch_row($albs)) {
			
			/* don't include albums with no pics */
			list($pic_count) = mysql_fetch_row(cpg_db_query( "SELECT COUNT(pid) FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE a.aid = $aid $public LIMIT 1" ));
			if (!$pic_count) continue;
			
			$date = date ( 'c', $lastmod);
			
			$urlalb = $xmlmap->addChild('url');
			$urlalb->addChild('loc', $base.'/thumbnails.php?album='.$aid);
			$urlalb->addChild('lastmod', $date);
			$urlalb->addChild('changefreq', 'daily');
			$urlalb->addChild('priority', '1');
		
			$pics = cpg_db_query("SELECT pid, filepath, filename, ctime, p.title, caption FROM {$CONFIG['TABLE_ALBUMS']} AS a INNER JOIN {$CONFIG['TABLE_PICTURES']} AS p ON p.aid = a.aid WHERE p.aid = '$aid'");
		
			while(list($pid, $filepath, $filename, $lastmod, $title, $caption) = mysql_fetch_row($pics)) {
				$date = date ( 'c', $lastmod);
				$splitfilename = explode('.', $filename);
				$file_pfx = $splitfilename[0];
				$filetype = $splitfilename[1];
				
				$urlpic = $xmlmap->addChild('url');
				$urlpic->addChild('loc', $base.'/displayimage.php?pos=-'.$pid);
				
				/* images */
				if($filetype == 'jpg' || $filetype == 'jpeg' || $filetype == 'png' || $filetype == 'gif' || 
				   $filetype == 'JPG' || $filetype == 'JPEG' || $filetype == 'PNG' || $filetype == 'GIF') {
					$image = $urlpic->addChild('image', NULL, 'http://www.google.com/schemas/sitemap-image/1.1');
					$image->addChild('loc', utf8_encode($base.'/'.$fullpath.'/'.$filepath.$filename), 'http://www.google.com/schemas/sitemap-image/1.1');
					if($caption)
						$image->addChild('caption', utf8_encode($caption), 'http://www.google.com/schemas/sitemap-image/1.1');
					if($title)
						$image->addChild('title', utf8_encode($title), 'http://www.google.com/schemas/sitemap-image/1.1');
				}
				
				/* video */
				elseif ($filetype == 'mpg' || $filetype == 'mpeg' || $filetype == 'mp4' || $filetype == 'm4v' || $filetype == 'mov' || 
						  $filetype == 'wmv' || $filetype == 'asf' || $filetype == 'avi' || $filetype == 'ra' || $filetype == 'ram' || 
						  $filetype == 'rm' || $filetype == 'flv' || $filetype == 'swf' || $filetype == 'MPG' || $filetype == 'MPEG' ||
						  $filetype == 'MP4' || $filetype == 'M4V' || $filetype == 'MOV' || $filetype == 'WMV' || $filetype == 'ASF' ||
						  $filetype == 'AVI' || $filetype == 'RA' || $filetype == 'RAM' || $filetype == 'RM' || $filetype == 'FLV' ||
						  $filetype == 'SWF') {
					$thumbnail = '';
					$thumbnail_exts = array( '.gif', '.png', '.jpg', '.jpeg', '.GIF', '.PNG', '.JPG', '.JPEG' );
					foreach ($thumbnail_exts as $ext) {
						if (file_exists($fullpath.'/'.$filepath.$CONFIG['thumb_pfx'].$file_pfx.$ext)) {
							$thumbnail = $fullpath.'/'.$filepath.$CONFIG['thumb_pfx'].$file_pfx.$ext;
							break;
						}
					}
					if($thumbnail == '')
						$thumbnail = $base.'/images/thumbs/thumb_nopic.png';
					$video = $urlpic->addChild('video', NULL, 'http://www.google.com/schemas/sitemap-video/1.1');
					$video->addChild('thumbnail_loc', utf8_encode($thumbnail), 'http://www.google.com/schemas/sitemap-video/1.1');
					if($title)
						$video->addChild('title', utf8_encode($title), 'http://www.google.com/schemas/sitemap-video/1.1');
					else $video->addChild('title', utf8_encode($filename), 'http://www.google.com/schemas/sitemap-video/1.1');
					if($caption)
						$video->addChild('description', utf8_encode($title), 'http://www.google.com/schemas/sitemap-video/1.1');
					else $video->addChild('description', utf8_encode($filename), 'http://www.google.com/schemas/sitemap-video/1.1');
					$video->addChild('content_loc', utf8_encode($base.'/'.$fullpath.'/'.$filepath.$filename), 'http://www.google.com/schemas/sitemap-video/1.1');
				}
				
			$urlpic->addChild('lastmod', $date);
			$urlpic->addChild('changefreq', 'monthly');
			$urlpic->addChild('priority', '0.5');
			}
		}
		
		/* Format XML to save indented tree rather than one line */
		$dom = new DOMDocument('1.0');
		$dom->preserveWhiteSpace = false;
		$dom->formatOutput = true;
		$dom->loadXML($xmlmap->asXML());
		
		/* Save XML to file */
		if (!$dom->save('sitemaps/cat'.$cid.'-sitemap.xml')) {
			if(!mkFileFix($dom->saveXML(), 'sitemaps/cat'.$cid.'-sitemap.xml')) {
				$fileError = true;
				break;
			}
		}
		$sitemaphead = '';
	}
}

/* Redirect user after success or remain on same page on failure */
if ($dirError) {
	pageheader($lang_common['information']);
	msg_box('', $lang_plugin_sitemap_gen['dirError'], '', '', 'error');
}
elseif ($fileError) {
	pageheader($lang_common['information']);
	msg_box('', $lang_plugin_sitemap_gen['fileError'], '', '', 'error');
	echo 'Message: '.$message;
}
else {
	pageheader($lang_common['information'],"<meta http-equiv=\"refresh\" content=\"4;url=".$base.'/sitemaps/sitemap_index.xml'.'" \>');
	msg_box('', $lang_plugin_sitemap_gen['success'], '', '', 'success');
}
pagefooter();
?>